
package de.ivu.elect.business.benutzerverwaltung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameter;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractBenutzerParameterEdit {

  @Inject
  protected BenutzerParameterDAO dao;

  @Inject
  protected BenutzerParameterExtendedDAO extendedDao;

  public void delete(BenutzerParameter entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(BenutzerParameter entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(BenutzerParameter entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected BenutzerParameter getAttachedEntity(BenutzerParameter entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected BenutzerParameter getAttachedAndRefreshedEntity(BenutzerParameter entity) {
    return dao.refresh(entity);
  }
}
